--[[
-- Chat Command Library
-- `bgR}hCu
-- version 1.3 (2009-01-23)
Author:
	silica as ~̐l
	http://winter.sgv417.jp/
Document:
	http://pc3merchant.net/ai_antenna/index.php?Dev%2FLib%2Fchat.lua
--]]
chat = {	-- O
	AI_PATH   = "./AI/",	-- ftHgAI
--	AI_PATH   = "./AI/USER_AI/",	-- JX^AI
	USER = {	-- gp҂̖Oi̖O̖߂󂯕tj
		"",	-- Player1
		"",	-- Player2
	},
	USE_TALK  = true,	-- قTALKɂ閽ߗo [true, false]
	RECORD    = false,	-- L^[true: ړ, false:폜, nil:u]
	CHAT_PATH = "./Chat/",	-- Z[u`bgtH_
	CHAT_FILE = "./Chat/Chat.txt",	-- t@C
	CHAT_LOG  = "./Chat/Chat_log.txt",	-- e|
	BM_PATH   = "./Chat_BM/",	-- ogbZ[W
	BM_FILE   = "./Chat_BM/Chat_BM.txt",	-- t@C
	BM_LOG    = "./Chat_BM/Chat_BM_log.txt",	-- e|
	DATE_FOR  = "%Y-%m-%dT%H-%M-%S",	-- ISO 8601/W3C-DTFttH[}bg
	-- PREFIXRgAEgƁAR}h̃p^[}b`̓ItɂȂ܂B
	-- R}hɓ{gĖ肪NƂ́ARgAEg邱ƁB
	PREFIX    = "!",	-- Ou: R}h̑Oɕt镶
	LOGSIZE   = -500,	-- ǍO̒i疽߂͈́j
}

if not table then	-- e[u table ֐ƂAւp
	local internal = {}	-- Ԃ̍Č
	table = {}
	
	function table.getn( t )
		if t.n then return t.n end
		if internal[ t ] then return internal[ t ] end
		local n = 0
		for i, v in ipairs( t ) do
			n = i
		end

		return n
	end
end

-- t@CRs[
function os.copy(filename1, filename2)
	local fp1, err = io.open(filename1, "r")	-- Ǎp
	local fp2, err = io.open(filename2, "w")
	if(fp1 == nil) then
		return nil, "filename1 can't open"	-- t@CJs
	end
	if(fp2 == nil) then
		return nil, "filename2 can't open"	-- t@C쐬s
	end
	for line in fp1:lines(filename1) do	-- Rs[Jn
		fp2:write(line.."\n")
	end
	fp1:close()
	fp2:close()
end

-- e[u̗vft]
function table.reverse( t )
	local i = table.getn( t ) + 1
	local t2 = {}
	for j, line in ipairs( t ) do
		t2[i-j] = line
	end

	return t2
end

-- 
-- s當؂oĒPe[u쐬
function string.word(str)
	local t = {}	-- 
	local i = 1
	-- EELF[%a%d%-%_%(%)%.%,%%\\\'\"]+ȌɋLq
	for word in string.gfind(str, "[^%s]+") do	-- 󔒕ȊȎS
		t[i] = word
		i = i + 1
	end

	return t
end

-- t@CɃbZ[Wo
function chat:write(filename, str, mode)
	local fp = io.open(filename, mode or "a")	-- wȂ:ǋL[h
	if(fp == nil) then return end
	fp:write(str)
	fp:close()
end

-- g[XAG[o
function chat:trace(filename, str, mode)
	self:write(filename, os.date("%Y/%m/%d %H:%M:%S").." : "..str.."\n", mode)
end

-- قTALKɃbZ[Wo
function chat:homuntalk(str, mode)
	self:write(self.AI_PATH.."message.txt", str.."\n", mode)
end

-- G[o֐ɍւċL^
function chat:pcall(func, ...)
	local ok, err = pcall(func, unpack(arg))
	if(not ok) then
		self:trace(self.AI_PATH.."Error.txt", err)
		func = function() end	-- G[Ȃ֐ɂ
	end
end

-- OǍ
function chat:open(filename, whence, offset)
	local fp, err = io.open(filename)
	if(fp == nil) then return nil, err end
	local t = {}	-- `bgOe[u
	local i = 1	-- sJE^

	fp:seek(whence, offset)	-- whencëʒuoffsetoCgi߂
	if(offset ~= nil) then fp:read() end	-- ŏ̈s؂̂
	for line in fp:lines() do	-- Ȍ͔z
		t[i] = line
		i = i + 1
	end
	fp:close()

	return t
end

-- O
function chat:separate(log)
	local msglog, syslog = {}, {}
	local imsg, isys = 1, 1
	local name, talk
	local delimiter = " : "
	local length = string.len(delimiter)

	for i, line in pairs(log) do
		local sep, tmp = string.find(line, delimiter)
		if(sep ~= nil) then	-- bAWiline" : "܂ށj
			name = string.sub(line, 1, sep-1)	-- O
			talk = string.sub(line, sep+length)	-- b
			msglog[imsg] = {name, talk}
			imsg = imsg + 1
		else	-- AiEXAVXeAXLbZ[W
			syslog[isys] = line
 			isys = isys + 1
		end
	end

	return msglog, syslog
end

-- name͎sĂ邩H
function chat:permit(name)
	for k,v in pairs(self.USER) do
		if(v == name) then return true end
	end

	return false
end

-- O
function chat:parse(msglog)
	local delimiter, tmp
	if self.PREFIX then	-- Ou`FbN
		pattern = "^"..self.PREFIX
		init = nil	-- JnʒuAȗ1
		plain = nil
	else	-- Ouݒ肵Ȃ
		pattern = ""
		init = 1	-- JnʒuAȗ1
		plain = true	-- string.find̃p^[}b`O@\It
	end
	for i, log in ipairs(msglog) do	-- log = {name, talk}
		if(self:permit(log[1])) then
			for k, v in pairs(self.command) do
				delimiter, tmp = string.find(log[2], pattern..k, init, plain)
				if(delimiter ~= nil) then
					return k, log[2]	-- R}hA
				end
			end
		end
	end
end

-- On
function chat:close(filename, path)
	local fp, err = io.open(filename)	-- t@C݂̑`FbN
	if(fp ~= nil) then
		fp:close()	-- t@C݂ĂB
		if(self.RECORD == true) then	-- Oړ
			os.copy(filename, path..os.date(self.DATE_FOR)..".txt")
			os.remove(filename)
		elseif(self.RECORD == false) then	-- O
			os.remove(filename)
		end	-- ̑̓Ou
	end
end

-- Oݒ
function chat:new(myid)
	local err, com, talk = {}
	self.myid = myid or -1	-- zAbIDiEȂ-1j
	self.ownerid = GetV(V_OWNER, myid)	-- vC[ID
	-- Öꕔ擾
	self.comlog, err = self:open(self.CHAT_FILE, "end", self.LOGSIZE)

	if(self.comlog == nil) then	-- Ot@CȂ
		return
	else	-- O΃O̍st]čŐVɂB
		self.comlog = table.reverse(self.comlog)	-- OŐVsɂ
		self.msglog, self.syslog = self:separate(self.comlog)	-- O
		com, talk = self:parse(self.msglog)	-- O
--		self.log, err = self:open(self.CHAT_PATH)	-- OS擾

		if(com ~= nil and talk ~= nil) then
			self.command[com](self, string.word(talk))	-- R}hsA
			if(self.USE_TALK) then	-- قTALKɏo
				self:homuntalk(string.format("%s %s : %s", os.date("%H:%M:%S"), com, talk))
			end
		end

		self:close(self.CHAT_FILE, self.CHAT_PATH)	-- On
		self:close(self.BM_FILE, self.BM_PATH)
	end
end

-- `bgR}h
-- command: e[ui̓R}hj
-- Z[u`bg /savechat
function chat:savechat(command)
	os.copy(self.CHAT_FILE, self.CHAT_PATH..os.date(self.DATE_FOR)..".txt")
	os.copy(self.BM_FILE, self.BM_PATH..os.date(self.DATE_FOR)..".txt")
end

-- I
function chat:exit(command)
	self:close(self.CHAT_FILE)	-- On
	self:close(self.BM_FILE)
	os.exit()	-- I
end

-- قTALKɃbZ[Wo
function chat:clsmsg(message)
	self:homuntalk("", "w")	-- g𔒎
end

--[[
-- zNXEb
--]]
-- AҁFľɈړ
-- xg񂾏ꏊłl̋߂Ɉړ܂B
function chat:come(command)
	local x, y = GetV(V_POSITION, self.ownerid)
	MoveToOwner(self.myid)
	Move(self.myid, x, y)
end

-- ړFzEb猩ʒu
-- 1xɈړ\Ȃ̂̓z猩15Z܂Łi`j
function chat:go(command)
	local x, y = GetV(V_POSITION, self.myid)
	-- ̗L`FbNAnilȂ0w聁ړȂB
	if(command[2] == nil) then command[2] = 0 end
	if(command[3] == nil) then command[3] = 0 end
	Move(self.myid, x + command[2], y + command[3])
end

-- ړFl猩ʒu
function chat:set(command)
	local x, y = GetV(V_POSITION, self.ownerid)
	-- ̗L`FbNAnilȂ0w聁l̈ʒuɖ߂B
	if(command[2] == nil) then command[2] = 0 end
	if(command[3] == nil) then command[3] = 0 end
	Move(self.myid, x + command[2], y + command[3])
end

--[[
-- zNXp
--]]
-- ً}FzSP40ȏ, SkillLvȗ
-- SP: 15+SkillLv~5, Lv1-5
function chat:urgent(command)
	local lv
	-- ^ǂH
	if(type(command[2]) == "number") then
		lv = command[2]
	else
		lv = 5	-- ftHgLv5
	end
	local sp = 15 + (lv * 5)
	local mysp = GetV(V_SP, myid)	-- žSP
	if(100 <= mysp and mysp <= 150) then
	-- SP100ȏ`150ȉȂ烁^`FWSPS
		self:mental()	-- ftHgLv3
	end
	if(mysp >= sp) then
		SkillObject(self.myid, lv, 8002, self.myid)	-- ً}
	end
end

-- ^`FWFzSP100ȏ, SkillLvȗ
-- SP: Œ, Lv1-3
function chat:mental(command)
	local lv
	-- ^ǂH
	if(type(command[2]) == "number") then
		lv = command[2]
	else
		lv = 3	-- ftHgLv3
	end
	if(GetV(V_SP, self.myid) >= 100) then
		SkillObject(self.myid, lv or 3, 8004, self.myid)	-- ^`FW
	end
end

-- LXOFzSP10ȏ, SkillLvȗ
-- SP: Œ, Lv1-5
function chat:castling(command)
	local lv
	-- ^ǂH
	if(type(command[2]) == "number") then
		lv = command[2]
	else
		lv = 5	-- ftHgLv5
	end
	if(GetV(V_SP, self.myid) >= 10) then
		SkillObject(self.myid, lv or 5, 8005, self.myid)	-- LXO
	end
end

-- fBtFXFzSP20-45ȏ, SkillLvȗ
-- SP: 20-45, Lv1-5
function chat:bulwark(command)
	local lv
	-- ^ǂH
	if(type(command[2]) == "number") then
		lv = command[2]
	else
		lv = 5	-- ftHgLv5
	end
	if(GetV(V_SP, self.myid) >= 45) then	-- őSPȏ
		SkillObject(self.myid, lv or 5, 8006, self.myid)	-- fBtFX
	end
end
chat.defence = chat.bulwark	-- fBtFX

-- ubhXgFzSP120ȏ, SkillLvȗ
-- SP: Œ, Lv1-3
function chat:bloodlust(command)
	local lv
	-- ^ǂH
	if(type(command[2]) == "number") then
		lv = command[2]
	else
		lv = 3	-- ftHgLv5
	end
	if(GetV(V_SP, self.myid) >= 120) then
		SkillObject(myid, lv or 5, 8008, self.myid)	-- ubhXg
	end
end


-- {R}hXg
chat.command = {
	["savechat"] = chat.savechat,	-- alternative /savechat
	["save"]     = chat.savechat,
	["exit"]     = chat.exit,	-- exit
	["clsmsg"]   = chat.clsmsg,	-- message clear
	["come"]     = chat.come,	-- return
	["go"]       = chat.go,	-- go
	["set"]      = chat.set,	-- set
	["urgent"]   = chat.urgent,	-- ً}
	["ea"]       = chat.urgent,	-- ً}
	["mental"]   = chat.mental,	-- ^`FW
	["mc"]       = chat.mental,	-- ^`FW
	["castling"] = chat.castling,	-- LbXO
	["cas"]      = chat.castling,	-- LbXO
	["defence"]  = chat.bulwark,	-- fBtFX
	["def"]      = chat.bulwark,	-- fBtFX
	["blood"]    = chat.bloodlust,	-- ubhXg
	["bl"]       = chat.bloodlust,	-- ubhXg
	["ۑ"]     = chat.savechat,	-- /savechat
	["I"]     = chat.exit,	-- I
	["߂"]     = chat.come,	-- A
	["s"]     = chat.go,	-- ړ
	["zu"]     = chat.set,	-- zu
}
